<?php
/**
* UserImportPlugin.class.php
*
* 
*
*
* @author		Andr Noack <noack@data-quest.de>, Suchi & Berg GmbH <info@data-quest.de>
* @version		$Id:$
*/
// +---------------------------------------------------------------------------+
// This file is part of Stud.IP
// UserImportPlugin.class.php
// importiert Nutzer aus csv Datei
// Copyright (C) 2007 Andr Noack <noack@data-quest.de>
// Suchi & Berg GmbH <info@data-quest.de>
// +---------------------------------------------------------------------------+
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or any later version.
// +---------------------------------------------------------------------------+
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// +---------------------------------------------------------------------------+

require_once("lib/functions.php");
require_once("lib/msg.inc.php");
require_once("lib/datei.inc.php");
require_once("lib/classes/UserManagement.class.php");

class smtp_dummy {
	function SendMessage(){}
}

class UserImportPlugin extends AbstractStudIPAdministrationPlugin {
	
	var $_imported_user;
	var $user_data_mapping;
	
	function UserImportPlugin() {
		
		parent::AbstractStudIPAdministrationPlugin();
		
		$this->setPluginiconname("img/plugin.png");
		
		$navigation =& new PluginNavigation();
		$navigation->setDisplayname($this->getDisplayname());
		$this->setNavigation($navigation);
		$top_navigation =& new PluginNavigation();
		$top_navigation->setDisplayname($this->getDisplayname());
		$this->setTopnavigation($top_navigation);
		$this->_imported_user =& $_SESSION['_imported_user'];
		
		$this->user_data_mapping['Vorname']['table'] = 'auth_user_md5';
		$this->user_data_mapping['Vorname']['check'] = true;
		$this->user_data_mapping['Nachname']['table'] = 'auth_user_md5';
		$this->user_data_mapping['Nachname']['check'] = true;
		$this->user_data_mapping['Email']['table'] = 'auth_user_md5';
		$this->user_data_mapping['Email']['check'] = true;
		$this->user_data_mapping['perms']['table'] = 'auth_user_md5';
		$this->user_data_mapping['perms']['check'] = false;
		$this->user_data_mapping['username']['table'] = 'auth_user_md5';
		$this->user_data_mapping['username']['check'] = false;
		$this->user_data_mapping['auth_plugin']['table'] = 'auth_user_md5';
		$this->user_data_mapping['auth_plugin']['check'] = false;
		$this->user_data_mapping['title_front']['table'] = 'user_info';
		$this->user_data_mapping['title_front']['check'] = false;
		$this->user_data_mapping['title_rear']['table'] = 'user_info';
		$this->user_data_mapping['title_rear']['check'] = false;
		$this->user_data_mapping['geschlecht']['table'] = 'user_info';
		$this->user_data_mapping['geschlecht']['check'] = false;
		$this->user_data_mapping['Anrede']['func'] = 'map_anrede';
	}
	
	function getDisplayname() {
		return _("Nutzer Import");
	}
	
	function reduce_diakritika_from_iso88591($text) {
		$text = str_replace(array("","","","","","",""), array('a','Ae','o','Oe','u','Ue','ss'), $text);
		$text = str_replace(array('','','','','',''), 'A' , $text);
		$text = str_replace(array('','','','','',''), 'a' , $text);
		$text = str_replace(array('','','',''), 'E' , $text);
		$text = str_replace(array('','','',''), 'e' , $text);
		$text = str_replace(array('','','',''), 'I' , $text);
		$text = str_replace(array('','','',''), 'i' , $text);
		$text = str_replace(array('','','','',''), 'O' , $text);
		$text = str_replace(array('','','','',''), 'o' , $text);
		$text = str_replace(array('','',''), 'U' , $text);
		$text = str_replace(array('','',''), 'u' , $text);
		$text = str_replace(array('','','','','','','',''), array('C','c','D','N','Y','n','y','y') , $text);
		return $text;
	}
	
	function CSV2Array($content, $delim = ';', $encl = '"', $optional = 1) {
		if ($content[strlen($content)-1]!="\r" && $content[strlen($content)-1]!="\n")
		$content .= "\r\n";
		
		$reg = '/(('.$encl.')'.($optional?'?(?(2)':'(').
		'[^'.$encl.']*'.$encl.'|[^'.$delim.'\r\n]*))('.$delim.
		'|[\r\n]+)/smi';
		
		preg_match_all($reg, $content, $treffer);
		$linecount = 0;
		
		for ($i = 0; $i<=count($treffer[3]);$i++) {
			$liste[$linecount][] = trim($treffer[1][$i],$encl);
			if ($treffer[3][$i] != $delim) $linecount++;
		}
		return $liste;
	}
	
	function map_direkt($field, $value){
		if(isset($this->user_data_mapping[$field]['table'])){
			return array($this->user_data_mapping[$field]['table'].'.'.$field => $value);
		}
	}
	
	function map_anrede($field, $value){
		return $this->map_direkt('geschlecht', (strtolower($value) == 'frau' ? 1 : 0));
	}
	
	function create_username($nachname, $vorname, $postfix, $prefix){
		if(strlen($vorname) < 2) $nachname = str_pad($nachname, 4, "_", STR_PAD_LEFT );
		$uname = $testuname = preg_replace('/[^a-zA-Z0-9_@-]/', '', strtolower($this->reduce_diakritika_from_iso88591(trim($vorname) . '_' . $nachname)));
		$postfix = preg_replace('/[^a-zA-Z0-9_@-]/', '', strtolower($this->reduce_diakritika_from_iso88591($postfix)));
		$prefix = preg_replace('/[^a-zA-Z0-9_@-]/', '', strtolower($this->reduce_diakritika_from_iso88591($prefix)));
		$db = new DB_Seminar();
		$c = 0;
		do {
			if ($c) $testuname = $uname.$c;
			++$c;
			$db->query("SELECT username FROM auth_user_md5 WHERE username='".$prefix.$testuname.$postfix."'");
		} while ($db->next_record());
		return $prefix.$testuname.$postfix;
	}
	
	function check_username($username){
		$db = new DB_Seminar();
		$db->query("SELECT username FROM auth_user_md5 WHERE username LIKE '".mysql_escape_string($username)."'");
		$db->next_record();
		return $db->f(0);
	}
	
	function check_user($nachname, $vorname){
		$db = new DB_Seminar();
		$db->query("SELECT username FROM auth_user_md5 WHERE Vorname LIKE '".mysql_escape_string($vorname)."%' AND Nachname LIKE '".mysql_escape_string($nachname)."'");
		$db->next_record();
		return $db->f(0);
	}
	
	function compat_file_get_contents($filename){
		if (function_exists('file_get_contents')){
			return @file_get_contents($filename);
		} else {
			$file = @file($file);
			return (!$file ? false : implode('', $file));
		}
	}
	function actionShow() {
		ini_set('display_errors',1);
		error_reporting(E_ALL & ~E_NOTICE);
		global $auth, $perm, $user, $PHP_SELF;
		$db = new DB_Seminar();
		$db2 = new DB_Seminar();
		$msg = array();
		
		if (isset($_REQUEST['fileupload_x'])){
			$this->_imported_user = array();
			$uploadfile = $GLOBALS['TMP_PATH'] . '/' . md5(uniqid('bldsofubsod',1));
			if (move_uploaded_file($_FILES['userfile']['tmp_name'], $uploadfile)) {
				$imported_user = $this->CSV2Array($this->compat_file_get_contents($uploadfile));
				@unlink($uploadfile);
				$check = array();
				foreach($this->user_data_mapping as $field => $mapping){
					if($mapping['check'] && !in_array($field, $imported_user[0])){
						$check[] = $field;
					}
				}
				if(count($check)){
					$imported_user = null;
					$msg[] = array('error', _("Die hochgeladene Datei hat ein falsches Format. In der ersten Zeile fehlen folgende Feldnamen:")
					. '<br><b>' . join(', ', $check) . '</b>');
				} else {
					$headings = array_flip(array_shift($imported_user));
					foreach($imported_user as $c => $one_user){
						$i_user = array();
						foreach($this->user_data_mapping as $field => $mapping){
							$value = trim($one_user[$headings[$field]]);
							if ($value){
								$func = $mapping['func'] ? $mapping['func'] : 'map_direkt';
								$i_user = array_merge($i_user, $this->$func($field,$value,$c));
							}
						}
						if ($i_user['auth_user_md5.Nachname'] && $i_user['auth_user_md5.Email']){
							if(!$i_user['auth_user_md5.username']){
								$uname = $this->create_username($i_user['auth_user_md5.Nachname'], $i_user['auth_user_md5.Vorname'], trim($_REQUEST['postfix']), trim($_REQUEST['prefix']));
								$i_user['auth_user_md5.username'] = $uname;
							} else {
								$uname = $i_user['auth_user_md5.username'];
								$i_user['username_exists'] = $this->check_username($i_user['auth_user_md5.username']);
							}
							if(!$i_user['auth_user_md5.perms']) $i_user['auth_user_md5.perms'] = 'autor';
							if (!isset($i_user['auth_user_md5.Vorname'])) $i_user['auth_user_md5.Vorname'] = ' ';
							if (!isset($i_user['auth_user_md5.auth_plugin'])) $i_user['auth_user_md5.auth_plugin'] = 'standard';
							$this->_imported_user[$uname] = $i_user;
							$this->_imported_user[$uname]['exists'] = $this->check_user($i_user['auth_user_md5.Nachname'], $i_user['auth_user_md5.Vorname']);
							$this->_imported_user[$uname]['select'] = !($this->_imported_user[$uname]['exists'] || $this->_imported_user[$uname]['username_exists']);
						}
					}
					if (count($this->_imported_user)){
						$msg[] = array('msg', _("Upload erfolgreich.") .' '. sprintf(_("%s Nutzer erkannt."), count($this->_imported_user)));
					} else {
						$msg[] = array('error', _("In der hochgeladenen Datei konnten keine Nutzer erkannt werden."));
					}
				}
			}
		}
		if (isset($_REQUEST['cancel_x'])){
			$this->_imported_user = array();
		}
		
		if (isset($_REQUEST['create_account_x']) && is_array($_REQUEST['selected_user'])){
			$umanager = new UserManagement();
			$smtp = $umanager->smtp;
			$dummy_smtp = new smtp_dummy;
			if ($_REQUEST['disable_mail_host_check']) $GLOBALS['MAIL_VALIDATE_BOX'] = false;
			foreach($this->_imported_user as $uname => $udetail){
				if (isset($_REQUEST['selected_user'][$uname])){
					unset($udetail['select']);
					unset($udetail['exists']);
					$umanager->user_data = array();
					$umanager->msg = '';
					if($udetail['auth_user_md5.auth_plugin'] != 'standard'){
						$umanager->smtp = $dummy_smtp;
					} else {
						$umanager->smtp = $smtp;
					}
					if ($umanager->createNewUser($udetail)){
						$msg[] = array('msg', sprintf(_("Nutzer %s wurde angelegt"), $uname));
						$user_id = $umanager->user_data['auth_user_md5.user_id'];
						if ($_REQUEST['select_inst_id'] && $perm->have_studip_perm('admin', $_REQUEST['select_inst_id'])){
							$db = new DB_Seminar();
							$db->query(sprintf("INSERT INTO user_inst (user_id,Institut_id,inst_perms) VALUES ('%s','%s','%s')",
							$user_id, $_REQUEST['select_inst_id'], $umanager->user_data['auth_user_md5.perms']));
							if ($db->affected_rows()){
								$umanager->storeToDatabase();
							}
						}
						unset($this->_imported_user[$uname]);
					} else {
						$msg[] = array('error', sprintf(_("Nutzer %s konnte nicht angelegt werden:"), $uname)
						.'<div style="margin-left:10px"><table border="0" cellpadding="0" cellspacing="0">'
						. parse_msg_to_string($umanager->msg,"","blank",1,false,true)
						.'</table></div>');
					}
				} else {
					$this->_imported_user[$uname]['select'] = false;
				}
			}
		}
		
		echo "\n" . cssClassSwitcher::GetHoverJSFunction() . "\n";
		?>
		<table border="0" bgcolor="#000000" align="center" cellspacing="0" cellpadding="0" width="100%">
		<tr>
		<td class="blank">&nbsp;</td>
		</tr>
		<?
		if (count($msg)){
			echo "\n<tr><td class=\"blank\"><table width=\"99%\" border=\"0\" cellpadding=\"2\" cellspacing=\"0\">";
			parse_msg_array($msg, "blank", 1 ,false);
			echo "\n</table></td></tr>";
		}
		?>
		<tr>
		<td class="blank">
		<form enctype="multipart/form-data" action="<?=$_SERVER['REQUEST_URI']?>" method="POST">
		&nbsp;
		<?=_("csv Datei zum Upload:")?>
		&nbsp;
		<input name="userfile" size="50" accept="text/*" type="file"/>
		&nbsp;
		<?=makeButton('absenden', $mode = "input", $tooltip = _("Ausgewhlte Datei uploaden"), 'fileupload')?>
		&nbsp;
		<?=makeButton('zuruecksetzen', $mode = "input", $tooltip = _("Zurcksetzen"), 'cancel')?>
		</td>
		</tr>
		<tr>
		<td class="blank">
		&nbsp;
		<?=_("Prfix fr den Nutzernamen:")?>
		&nbsp;
		<input name="prefix" size="10" type="text" value=""/>
		&nbsp;
		<?=_("Suffix fr den Nutzernamen:")?>
		&nbsp;
		<input name="postfix" size="10" type="text" value=""/>
		&nbsp;
		</form>
		</td>
		</tr>
		<tr>
		<td class="blank">&nbsp;</td>
		</tr>
		
		<?
		if (count($this->_imported_user)){
			$cssSw = new cssClassSwitcher();
			$cssSw->enableHover();
			echo '<tr><td class="blank">';
			echo '<form name="admin_user_import" method="POST" action="'.$_SERVER['REQUEST_URI'].'">';
			echo '<table cellpadding="2" cellspacing="0" bgcolor="#eeeeee" align="center" width="75%">';
			foreach($this->_imported_user as $username => $userdetail){
				echo chr(10).'<tr  ' . $cssSw->getHover().'><td ' . $cssSw->getFullClass() . '><b>' . $username . '</b></td>';
				echo chr(10).'<td ' . $cssSw->getFullClass() . '>' . htmlReady($userdetail['user_info.title_front'] 
				. ' ' . $userdetail['auth_user_md5.Vorname']
				. ' ' . $userdetail['auth_user_md5.Nachname']
				. ' ' . $userdetail['user_info.title_rear']).'</td>';
				echo chr(10).'<td ' . $cssSw->getFullClass() . '>' . htmlReady($userdetail['auth_user_md5.perms']) . '</td>';
				echo chr(10).'<td ' . $cssSw->getFullClass() . '>' . htmlReady($userdetail['auth_user_md5.Email']) . '</td>';
				echo chr(10).'<td ' . $cssSw->getFullClass() . '>' . htmlReady($userdetail['auth_user_md5.auth_plugin']) . '</td>';
				echo chr(10).'<td ' . $cssSw->getFullClass() . '>';
				if(!$userdetail['username_exists']){
					echo '<input type="checkbox" value="1" name="selected_user['.$username.']" '.($userdetail['select'] ? ' checked ' : '') .'>';
				} else {
					echo '&nbsp;';
				}
				echo '</td>';
				echo chr(10).'<td ' . $cssSw->getFullClass() . '>';
				if(!$userdetail['username_exists']){
					echo ($userdetail['exists'] ? '<a href="new_user_md5.php?details='.$userdetail['exists'].'"><img '.tooltip(_("Es existiert bereits min. ein Nutzer mit diesem Namen! Klicken Sie, um zu den Details zu kommen.")).' src="'.$GLOBALS['ASSETS_URL'].'images/ausruf_small2.gif" border="0" align="absmiddle"></a>' : '&nbsp;') ;
				} else {
					echo '<a href="new_user_md5.php?details='.$userdetail['username_exists'].'"><img '.tooltip(_("Es existiert bereits ein Nutzer mit diesem Nutzernamen! Klicken Sie, um zu den Details zu kommen.")).' src="'.$GLOBALS['ASSETS_URL'].'images/x_small2.gif" border="0" align="absmiddle"></a>';
				}
				echo '</td>';
				echo chr(10).'</tr>'; 
				$cssSw->switchClass();
			}
			echo chr(10).'<tr><td colspan="7" class="blank" align="right"><input type="checkbox" name="disable_mail_host_check" value="1">&nbsp; '._("Mailboxberprfung deaktivieren").'</td></tr>';
			echo chr(10).'<tr><td  colspan="5" class="blank">';
			echo chr(10).'<font size=-1><select name="select_inst_id" size="1" style="vertical-align:middle">';
			if ($auth->auth['perm'] == "root"){
				$db->query("SELECT Institut_id, Name, 1 AS is_fak  FROM Institute WHERE Institut_id=fakultaets_id ORDER BY Name");
			} elseif ($auth->auth['perm'] == "admin") {
				$db->query("SELECT a.Institut_id,Name, IF(b.Institut_id=b.fakultaets_id,1,0) AS is_fak FROM user_inst a LEFT JOIN Institute b USING (Institut_id)  
				WHERE a.user_id='$user->id' AND a.inst_perms='admin' ORDER BY is_fak,Name");
			} else {
				$db->query("SELECT a.Institut_id,Name FROM user_inst a LEFT JOIN Institute b USING (Institut_id) WHERE inst_perms IN('tutor','dozent') AND user_id='$user->id' ORDER BY Name");
			}
			
			printf ("<option value=\"0\">%s</option>\n", _("-- bitte Einrichtung ausw&auml;hlen (optional) --"));
			while ($db->next_record()){
				printf ("<option value=\"%s\" style=\"%s\">%s </option>\n", $db->f("Institut_id"),($db->f("is_fak") ? "font-weight:bold;" : ""), htmlReady(substr($db->f("Name"), 0, 70)));
				if ($db->f("is_fak")){
					$db2->query("SELECT Institut_id, Name FROM Institute WHERE fakultaets_id='" .$db->f("Institut_id") . "' AND institut_id!='" .$db->f("Institut_id") . "' ORDER BY Name");
					while ($db2->next_record()){
						printf("<option value=\"%s\">&nbsp;&nbsp;&nbsp;&nbsp;%s </option>\n", $db2->f("Institut_id"), htmlReady(substr($db2->f("Name"), 0, 70)));
					}
				}
			}
			?>
			</select></font>
			</td>
			<td class="blank" colspan="2">
			<?=makeButton('anlegen', $mode = "input", $tooltip = _("Ausgewhlte Nutzeraccounts anlegen"), 'create_account')?>
			</td>
			</tr>
			<?
			echo '</table></form></td></tr>';
		} else {
			?>
			<tr>
			<td class="blank">
			<div style="border: 1px solid; padding: 5px; ">
			Hinweis:<br>
			Die csv Datei muss als Feldtrennzeichen das Semikolon benutzen, Felder knnen optional von doppelten Anfhrungszeichen
			eingeschlossen sein. Dies ist das bliche csv Format von MS Excel.
			Die erste Zeile muss die Feldnamen enthalten, folgende Feldnamen sind mglich:
			<br>
			<tt><?=join(', ', array_keys($this->user_data_mapping))?></tt>
			<br><br>
			Wenn der Nutzername nicht enthalten ist, wird er automatisch aus Prfix, Vorname, Nachname, Suffix gebildet. Wird ein anderer Wert als "standard" fr auth_plugin benutzt, so werden keine Passwortmails verschickt.
			<br><br>
			Beispiel:
<pre>
Anrede;Vorname;Nachname;Email
Herr;Marco;Bohnsack;bohnsack@data-quest.de
Herr;Andr;Noack;noack@data-quest.de
Frau;Bettina;Ro;ross@data-quest.de
</pre>
			</div>
			</td>
			</tr>
			<?
		}
		?>
		<tr>
		<td class="blank">&nbsp;</td>
		</tr>
		</table>
		<?
	}
}
?>
